import Head from "next/head";
import styles from "../styles/Home.module.css";
import CartTop from "../components/CardTop";
import Table from "../components/Table";
import axios from "axios";

const columns = [
  {
    name: "mobile",
    label: "Mobile",
  },
  {
    name: "customer",
    label: "Customer",
  },
  
  {
    name: "email",
    label: "Email",
  },
  {
    name: "orders",
    label: "Orders",
    options: {
      display: false,
    }
  },
  {
    name: "total",
    label: "Missed Orders",
  },
 
];

export default function Home(props) {
  
  
  const orders = props.orders.map((order) => {
      return {
      mobile: order.mobile,
      customer: order.orders[0].customer_details.customer,
      email: order.orders[0].customer_details.email,
      total: order.orders.length,
      orders: order.orders,
     
    };
  });

  return (
    <div className={styles.container}>
      <Head>
        <title>Poorvika - Missed Orders Tracking</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/logo.png" />
      </Head>
      <div className="container" style={{ paddingTop: "10px" }}>
        <div style={{ display: "flex", flexDirection: "row" }}>
          <CartTop
            title="Missed Orders"
            value={props.total}
            color="#e2b222"
          />
          <CartTop title="Open" value={props.open} color="#0dcaf0" />
          <CartTop title="Pending" value={props.pending} color="#92cab0" />
          <CartTop title="Closed" value={props.closed} color="#f7979e" />
        </div>
        <div>
          <Table data={orders} columns={columns} />
        </div>
      </div>
    </div>
  );
}

export async function getServerSideProps(req, res) {
  try {
        
    var orders = await axios
      .get("https://ao.poorvika.com/api/orders")
      .catch((err) => {
        console.log(err);
        throw new Error(err.message);
      });

      var open = 0,
    pending = 0,
    closed = 0, 
    total = orders.data.total_orders.length;

   
     
      orders.data.total_orders.map((order) => {
        if (order.status === "Open") open++;
          else if (order.status === "Pending") pending++;
             else closed++;
      });

      
    orders = orders.data.orders.map((order) => {
      return {
        mobile: order._id.mobile,
        orders: order.orders,
      
      };
    });

    return {
      props: {
        orders: orders,
        open,
        closed,
        pending,
        total
      },
    };
  } catch (err) {
    return {
      props: {
        orders: [],
        open:0,
        closed:0,
        pending:0,
        total:0
      },
    };
  }
}
